com.fasterxml.jackson.databind.deser

## Class AbstractDeserializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonDeserializer<Object>
  - - com.fasterxml.jackson.databind.deser.AbstractDeserializer

All Implemented Interfaces:
  ContextualDeserializer, NullValueProvider, Serializable

    public class AbstractDeserializer
    extends JsonDeserializer<Object>
    implements ContextualDeserializer, Serializable

Deserializer only used for abstract types used as placeholders during polymorphic type handling deserialization. If so, there is no real deserializer associated with nominal type, just `TypeDeserializer`; and any calls that do not pass such resolver will result in an error.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`JsonDeserializer.None`

### Field Summary

Fields
`protected boolean` `_acceptBoolean`
`protected boolean` `_acceptDouble`
`protected boolean` `_acceptInt`
`protected boolean` `_acceptString`
`protected Map<String,SettableBeanProperty>` `_backRefProperties`
`protected JavaType` `_baseType`
`protected ObjectIdReader` `_objectIdReader`
`protected Map<String,SettableBeanProperty>` `_properties`

### Constructor Summary

Constructors
`protected` `AbstractDeserializer(AbstractDeserializer base, ObjectIdReader objectIdReader, Map<String,SettableBeanProperty> props)`
`protected` `AbstractDeserializer(BeanDescription beanDesc)`
`` `AbstractDeserializer(BeanDeserializerBuilder builder, BeanDescription beanDesc, Map<String,SettableBeanProperty> backRefProps)` Deprecated.
`` `AbstractDeserializer(BeanDeserializerBuilder builder, BeanDescription beanDesc, Map<String,SettableBeanProperty> backRefProps, Map<String,SettableBeanProperty> props)`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`protected Object` `_deserializeFromObjectId(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method called in cases where it looks like we got an Object Id to parse and use as a reference.
`protected Object` `_deserializeIfNatural(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)`
`static AbstractDeserializer` `constructForNonPOJO(BeanDescription beanDesc)` Factory method used when constructing instances for non-POJO types, like `Map`s.
`JsonDeserializer<?>` `createContextual(DeserializationContext ctxt, BeanProperty property)` Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property.
`Object` `deserialize(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt)` Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles.
`Object` `deserializeWithType(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, TypeDeserializer typeDeserializer)` Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype.
`SettableBeanProperty` `findBackReference(String logicalName)` Method called by `BeanDeserializer` to resolve back reference part of managed references.
`ObjectIdReader` `getObjectIdReader()` Overridden to return true for those instances that are handling value for which Object Identity handling is enabled (either via value type or referring property).
`Class<?>` `handledType()` Method for accessing type of values this deserializer produces.
`boolean` `isCachable()` Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).
`Boolean` `supportsUpdate(DeserializationConfig config)` Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not.

### Methods inherited from class com.fasterxml.jackson.databind.JsonDeserializer

`deserialize, getDelegatee, getEmptyAccessPattern, getEmptyValue, getEmptyValue, getKnownPropertyNames, getNullAccessPattern, getNullValue, getNullValue, replaceDelegatee, unwrappingDeserializer`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### _baseType

    protected final JavaType _baseType

#### _objectIdReader

    protected final ObjectIdReader _objectIdReader

#### _backRefProperties

    protected final Map<String,SettableBeanProperty> _backRefProperties

#### _properties

    protected transient Map<String,SettableBeanProperty> _properties

#### _acceptString

    protected final boolean _acceptString

#### _acceptBoolean

    protected final boolean _acceptBoolean

#### _acceptInt

    protected final boolean _acceptInt

#### _acceptDouble

    protected final boolean _acceptDouble

### Constructor Detail

#### AbstractDeserializer

    public AbstractDeserializer(BeanDeserializerBuilder builder,
                                BeanDescription beanDesc,
                                Map<String,SettableBeanProperty> backRefProps,
                                Map<String,SettableBeanProperty> props)

Parameters:
  `props` - Regular properties: currently only needed to support property-annotated Object Id handling with property inclusion (needed for determining type of Object Id to bind)
Since:
  2.9

#### AbstractDeserializer

    @Deprecated
    public AbstractDeserializer(BeanDeserializerBuilder builder,
                                            BeanDescription beanDesc,
                                            Map<String,SettableBeanProperty> backRefProps)

Deprecated.

#### AbstractDeserializer

    protected AbstractDeserializer(BeanDescription beanDesc)

#### AbstractDeserializer

    protected AbstractDeserializer(AbstractDeserializer base,
                                   ObjectIdReader objectIdReader,
                                   Map<String,SettableBeanProperty> props)

Since:
  2.9

### Method Detail

#### constructForNonPOJO

    public static AbstractDeserializer constructForNonPOJO(BeanDescription beanDesc)

Factory method used when constructing instances for non-POJO types, like `Map`s.

Since:
  2.3

#### createContextual

    public JsonDeserializer<?> createContextual(DeserializationContext ctxt,
                                                BeanProperty property)
                                         throws JsonMappingException

Description copied from interface: `ContextualDeserializer`
Method called to see if a different (or differently configured) deserializer is needed to deserialize values of specified property. Note that instance that this method is called on is typically shared one and as a result method should NOT modify this instance but rather construct and return a new instance. This instance should only be returned as-is, in case it is already suitable for use.

Specified by:
  `createContextual` in interface `ContextualDeserializer`
Parameters:
  `ctxt` - Deserialization context to access configuration, additional deserializers that may be needed by this deserializer
  `property` - Method, field or constructor parameter that represents the property (and is used to assign deserialized value). Should be available; but there may be cases where caller cannot provide it and null is passed instead (in which case impls usually pass 'this' deserializer as is)
Returns:
  Deserializer to use for deserializing values of specified property; may be this instance or a new instance.
Throws:
  `JsonMappingException`

#### handledType

    public Class<?> handledType()

Description copied from class: `JsonDeserializer`
Method for accessing type of values this deserializer produces. Note that this information is not guaranteed to be exact -- it may be a more generic (super-type) -- but it should not be incorrect (return a non-related type).

Default implementation will return null, which means almost same same as returning `Object.class` would; that is, that nothing is known about handled type.

Overrides:
  `handledType` in class `JsonDeserializer<Object>`

#### isCachable

    public boolean isCachable()

Description copied from class: `JsonDeserializer`
Method called to see if deserializer instance is cachable and usable for other properties of same type (type for which instance was created).

Note that cached instances are still resolved on per-property basis, if instance implements `ResolvableDeserializer`: cached instance is just as the base. This means that in most cases it is safe to cache instances; however, it only makes sense to cache instances if instantiation is expensive, or if instances are heavy-weight.

Default implementation returns false, to indicate that no caching is done.

Overrides:
  `isCachable` in class `JsonDeserializer<Object>`

#### supportsUpdate

    public Boolean supportsUpdate(DeserializationConfig config)

Description copied from class: `JsonDeserializer`
Introspection method that may be called to see whether deserializer supports update of an existing value (aka "merging") or not. Return value should either be `Boolean.FALSE` if update is not supported at all (immutable values); `Boolean.TRUE` if update should usually work (regular POJOs, for example), or `null` if this is either not known, or may sometimes work.

Information gathered is typically used to either prevent merging update for property (either by skipping, if based on global defaults; or by exception during deserialization construction if explicit attempt made) if `Boolean.FALSE` returned, or inclusion if `Boolean.TRUE` is specified. If "unknown" case (`null` returned) behavior is to exclude property if global defaults used; or to allow if explicit per-type or property merging is defined.

Default implementation returns `null` to allow explicit per-type or per-property attempts.

Overrides:
  `supportsUpdate` in class `JsonDeserializer<Object>`

#### getObjectIdReader

    public ObjectIdReader getObjectIdReader()

Overridden to return true for those instances that are handling value for which Object Identity handling is enabled (either via value type or referring property).

Overrides:
  `getObjectIdReader` in class `JsonDeserializer<Object>`
Returns:
  ObjectIdReader used for resolving possible Object Identifier value, instead of full value serialization, if deserializer can do that; null if no Object Id is expected.

#### findBackReference

    public SettableBeanProperty findBackReference(String logicalName)

Method called by `BeanDeserializer` to resolve back reference part of managed references.

Overrides:
  `findBackReference` in class `JsonDeserializer<Object>`

#### deserializeWithType

    public Object deserializeWithType(com.fasterxml.jackson.core.JsonParser p,
                                      DeserializationContext ctxt,
                                      TypeDeserializer typeDeserializer)
                               throws IOException

Description copied from class: `JsonDeserializer`
Deserialization called when type being deserialized is defined to contain additional type identifier, to allow for correctly instantiating correct subtype. This can be due to annotation on type (or its supertype), or due to global settings without annotations.

Default implementation may work for some types, but ideally subclasses should not rely on current default implementation. Implementation is mostly provided to avoid compilation errors with older code.

Overrides:
  `deserializeWithType` in class `JsonDeserializer<Object>`
  `typeDeserializer` - Deserializer to use for handling type information
Throws:
  `IOException`

#### deserialize

    public Object deserialize(com.fasterxml.jackson.core.JsonParser p,
                              DeserializationContext ctxt)
                       throws IOException

Description copied from class: `JsonDeserializer`
Method that can be called to ask implementation to deserialize JSON content into the value type this serializer handles. Returned instance is to be constructed by method itself.

Pre-condition for this method is that the parser points to the first event that is part of value to deserializer (and which is never JSON 'null' literal, more on this below): for simple types it may be the only value; and for structured types the Object start marker or a FIELD_NAME.

The two possible input conditions for structured types result from polymorphism via fields. In the ordinary case, Jackson calls this method when it has encountered an OBJECT_START, and the method implementation must advance to the next token to see the first field name. If the application configures polymorphism via a field, then the object looks like the following.

          {
              "@class": "class name",
              ...
          }

Jackson consumes the two tokens (the `@class` field name and its value) in order to learn the class and select the deserializer. Thus, the stream is pointing to the FIELD_NAME for the first field after the @class. Thus, if you want your method to work correctly both with and without polymorphism, you must begin your method with:

           if (p.getCurrentToken() == JsonToken.START_OBJECT) {
             p.nextToken();
           }

This results in the stream pointing to the field name, so that the two conditions align.

Post-condition is that the parser will point to the last event that is part of deserialized value (or in case deserialization fails, event that was not recognized or usable, which may be the same event as the one it pointed to upon call).

Note that this method is never called for JSON null literal, and thus deserializers need (and should) not check for it.

Specified by:
  `deserialize` in class `JsonDeserializer<Object>`
Parameters:
  `p` - Parsed used for reading JSON content
  `ctxt` - Context that can be used to access information about this deserialization activity.
Returns:
  Deserialized value
Throws:
  `IOException`

#### _deserializeIfNatural

    protected Object _deserializeIfNatural(com.fasterxml.jackson.core.JsonParser p,
                                           DeserializationContext ctxt)
                                    throws IOException

Throws:
  `IOException`

#### _deserializeFromObjectId

    protected Object _deserializeFromObjectId(com.fasterxml.jackson.core.JsonParser p,
                                              DeserializationContext ctxt)
                                       throws IOException

Method called in cases where it looks like we got an Object Id to parse and use as a reference.

Throws:
  `IOException`